"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HighlightEditor = void 0;

var _ui = require("@edtr-io/ui");

var React = _interopRequireWildcard(require("react"));

var _renderer = require("./renderer");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

var Textarea = _ui.styled.textarea({
  height: '250px',
  width: '100%',
  padding: '5px',
  fontFamily: 'Menlo, Monaco, "Courier New", monospace'
});

var HighlightEditor = function HighlightEditor(props) {
  var state = props.state,
      focused = props.focused,
      editable = props.editable;
  return React.createElement(React.Fragment, null, !editable ? React.createElement(_renderer.HighlightRenderer, props) : React.createElement(Textarea, {
    value: state.text.value,
    name: "text",
    onChange: function onChange(e) {
      state.text.set(e.target.value);
    }
  }, state.text.value), focused ? React.createElement(React.Fragment, null, React.createElement("hr", null), "Language:", React.createElement("input", {
    value: state.language.value,
    onChange: function onChange(e) {
      state.language.set(e.target.value);
    },
    placeholder: "enter"
  }), React.createElement("div", null, React.createElement("a", {
    href: "https://github.com/conorhastings/react-syntax-highlighter/blob/master/AVAILABLE_LANGUAGES_HLJS.MD",
    rel: "noopener noreferrer",
    target: "_blank"
  }, "Available languages")), "Show line numbers", React.createElement("input", {
    type: "checkbox",
    onChange: function onChange(e) {
      state.lineNumbers.set(e.target.checked);
    },
    checked: state.lineNumbers.value
  })) : null);
};

exports.HighlightEditor = HighlightEditor;
//# sourceMappingURL=editor.js.map